/* XMMS UADE plugin
 *
 * Copyright (C) 2000-2001  Heikki Orsila
 *                          heikki.orsila@ee.tut.fi
 *                          http://www.ee.tut.fi/~heikki
 *
 * This plugin is based on xmms 0.9.6 wavplayer input plugin code. Since
 * then all code has been rewritten.
 *
 * the intital gui code was based onthe null-plugin by
 * Hvard Kvlen. Since then the gui code has evolved and was also mostly
 * rewritten.
 * Formatseditor inspired by nscache 0.3's mimetype editor by Stefan Ondrejicka
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/time.h>



/* FUNCTION DECLARATIONS */

void filemagic(unsigned char*, char*, char*);


/* Functions */

void filemagic(unsigned char* buf, char* pre, char* post) {
      /* char filemagic():
	detects formats like e.g.: tfmx1.5, hip, hipc, fc13, fc1.4	 
	    - tfmx 1.5 checking based on both tfmx DT and tfmxplay by jhp, 
	      and the EP by Don Adan/WT.
	    - tfmx 7v checking based on info by don adan, the amore file
	      ripping description and jhp's desc of the tfmx format.
	    - other checks based on e.g. various player sources from Exotica 
	      or by checking bytes with a hexeditor
	by far not complete...
       */

 int filesize=5122;
 int i,t,s,e=0;

 if ((buf[0x438] == 'M' && buf[0x439] == '.' && buf[0x43a] =='K' && buf[0x43b] =='.') ||
     (buf[0x438] == 'N' && buf[0x439] == '.' && buf[0x43a] =='T' && buf[0x43b] =='.') ||
     (buf[0x438] == 'M' && buf[0x439] == '!' && buf[0x43a] =='K' && buf[0x43b] =='!') ||
     (buf[0x438] == 'M' && buf[0x439] == '&' && buf[0x43a] =='K' && buf[0x43b] =='!') ||
     (buf[0x438] == '.' && buf[0x439] == 'M' && buf[0x43a] =='.' && buf[0x43b] =='K')){

		  strcpy (pre, "MOD\0");		/*generic Protracker or Clone*/
	          strcpy (post, "\0");

   } else if ((buf[0x438] == 'F' && buf[0x439] == 'L' && buf[0x43a] =='T' && buf[0x43b] =='4')||
	     (buf[0x438] == 'F' && buf[0x439] == 'L' && buf[0x43a] =='T' && buf[0x43b] =='8')||
	     (buf[0x438] == 'E' && buf[0x439] == 'X' && buf[0x43a] =='O' && buf[0x43b] =='4')||
    	     (buf[0x438] == 'E' && buf[0x439] == 'X' && buf[0x43a] =='O' && buf[0x43b] =='8')){
	    t=0;
            for (i=0; i<30*0x1e; i=i+0x1e){
		if (buf[0x2a + i] == 0 && buf[0x2b + i] ==0 &&
		    buf[0x2d + i] != 0) {
		    t = t + 1;				/* no of AM instr. */
		    }
	    }
	    if (t >1){
	       strcpy (pre, "ADSC\0");		/*Startrekker 4 AM / ADSC*/
	       strcpy (post, "\0");
		} else {
		  strcpy (pre, "MOD\0");	/*generic Startrekker MOD*/
	          strcpy (post, "\0");
		}

   } else if (((buf[0x438] >= '1' && buf[0x438] <= '3') && (buf[0x439] >= '0' && buf[0x439] <= '9') && buf[0x43a] =='C' && buf[0x43b] =='H') ||
              ((buf[0x438] >= '2' && buf[0x438] <= '8') && buf[0x439] == 'C' && buf[0x43a] =='H' && buf[0x43b] =='N')){
	       strcpy (pre, "\0");		/*filter out trackerformats we can't play*/
	       strcpy (post, "\0");

   } else if ((buf[0] == 0x60 && buf[2] == 0x60 && buf[4] ==0x48 && buf[5] == 0xe7) ||
	      (buf[0] == 0x60 && buf[2] == 0x60 && buf[4] ==0x41 && buf[5] == 0xfa) ||
	      (buf[0] == 0x60 && buf[1] == 0x00 && buf[4] == 0x60 && buf[5] == 0x00 && buf[8] ==0x48 && buf[9] == 0xe7)||
	      (buf[0] == 0x60 && buf[1] == 0x00 && buf[4] == 0x60 && buf[5] == 0x00 && buf[8] ==0x60 && buf[9] == 0x00 && buf[12] ==0x60 && buf[13] == 0x00 && buf[16] ==0x48 && buf[17] == 0xe7)){
	       strcpy (pre, "HIP\0");		/* Hippel*/
	       strcpy (post, "\0");

   } else if (buf[0x348] == '.' && buf[0x349] == 'Z' && buf[0x34A] =='A' && buf[0x34B] =='D' &&
              buf[0x34c] == 'S' && buf[0x34d] == '8' && buf[0x34e] =='9' && buf[0x34f] =='.'){
	       strcpy (pre, "MKII\0");		/* Mark II*/
	       strcpy (post, "\0");

   } else if (((buf[0] == 0x08 && buf[1] == 0xf9 && buf[2] ==0x00 && buf[3] == 0x01) &&
	       (buf[4] == 0x00 && buf[5] == 0xbb && buf[6] ==0x41 && buf[7] == 0xfa) &&
	        ((buf[0x25c] == 0x4e && buf[0x25d] == 0x75) || (buf[0x25c] == 0x4e && buf[0x25d] == 0xf9))) ||
	      ((buf[0] == 0x41 && buf[1] == 0xfa) &&
	       (buf[4] == 0xd1 && buf[5] == 0xe8) &&
	        (((buf[0x230] == 0x4e && buf[0x231] == 0x75) || (buf[0x230] == 0x4e && buf[0x231] == 0xf9)) ||		 
	         ((buf[0x29c] == 0x4e && buf[0x29d] == 0x75) || (buf[0x29c] == 0x4e && buf[0x29d] == 0xf9))
		   ))){		 
	       strcpy (pre, "SID1\0");		/* SidMon1 */
	       strcpy (post, "\0");

   } else if (buf[0] == 0x4e && buf[1] == 0xfa && 
               buf[4] == 0x4e && buf[5] == 0xfa &&
               buf[8] == 0x4e && buf[9] == 0xfa &&
               buf[0xc] == 0x4e && buf[0xd] == 0xfa){
	        for (i=0x10; i<256; i=i+2){
		  if (buf[i+0] == 0x4e && buf[i+1] ==0x75 && buf[i+2] == 0x47 && buf[i+3] == 0xfa &&
		     buf[i+12] == 0x4e && buf[i+13] ==0x75
		     ){ 
        	       strcpy (pre, "FRED\0");		/* FRED */
    		       strcpy (post, "\0");
    		       break;
	           }
		  }

   } else if (buf[0] == 0x60 && buf[1] == 0x00 && 
              buf[4] == 0x60 && buf[5] == 0x00 && 
              buf[8] == 0x60 && buf[9] == 0x00 &&
              buf[12] == 0x48 && buf[13] == 0xe7) {
	       strcpy (pre, "MA\0");		/*Music Assembler*/
	       strcpy (post, "\0");

   } else if (buf[0] == 0x00 && buf[1] == 0x00 &&
              buf[2] == 0x00 && buf[3] == 0x28 && 
	      (buf[7] >= 0x34 && buf[7] <= 0x64)&&
              buf[0x20] == 0x21 && (buf[0x21] == 0x54 || buf[0x21] ==0x44 ) &&
	      buf[0x22] == 0xff &&  buf[0x23] == 0xff) {
	       strcpy (pre, "SA-P\0");		/*SonicArranger Packed*/
	       strcpy (post, "\0");

   } else if (buf[0] == 0x4e && buf[1] == 0xfa &&
              buf[4] == 0x4e && buf[5] == 0xfa && 
	      buf[8] == 0x4e && buf[9] == 0xfa)
	      {
		s=((buf[2]*256) + buf[3]);

		if (s < filesize - 9){
		
		if (buf[2+s] == 0x4b && buf [3+s] == 0xfa &&
		    buf[6+s] == 0x08 && buf [7+s] == 0xad && buf[8+s] == 0x00 && buf[9+s] == 0x00)
			{
		          strcpy (pre, "MON\0");		/*M.O.N*/
		          strcpy (post, "\0");
			}
		}			

   } else if (buf[0] == 0x48 && buf[1] == 0xe7 &&  buf[2] == 0xf1 && buf[3] == 0xfe && 
              buf[4] == 0x61 && buf[5] == 0x00) {

		s=((buf[6]*256) + buf[7]);

		if (s < filesize - 17){
		    for (i=0; i<10; i=i+2)
		     {
		      if (buf[6+s+i] == 0x47 && buf[7+s+i] == 0xfa)
		        {

		    	    strcpy (pre, "DW\0");	/*Whittaker Type1*/
	        	    strcpy (post, "\0");	/* FIXME: incomplete */
			}
		    }
		}
/* Magic ID */

   } else if (buf[0x3a] == 'S' && buf[0x3b] == 'I' && buf[0x3c] == 'D' && 
              buf[0x3d] == 'M' && buf[0x3e] == 'O' && buf[0x3f] == 'N' &&
	      buf[0x40] == ' ' && buf[0x41] == 'I' && buf[0x42] == 'I' ) {
	       strcpy (pre, "SID2\0");		/* SidMon II*/
	       strcpy (post, "\0");

   } else if (buf[0x28] == 'R' && buf[0x29] == 'O' && buf[0x2a] == 'N' && 
              buf[0x2b] == '_' && buf[0x2c] == 'K' && buf[0x2d] == 'L' &&
	      buf[0x2e] == 'A' && buf[0x2f] == 'R' && buf[0x30] == 'E' && 
	      buf[0x31] == 'N') {
	       strcpy (pre, "RK\0");		/* Ron Klaren (CustomMade) */
	       strcpy (post, "\0");

   } else if (buf[0x3e] == 'A' && buf[0x3f] == 'C' && buf[0x40] =='T' && buf[0x41] =='I'&&
	     buf[0x42] == 'O' && buf[0x43] == 'N' && buf[0x44] =='A' && buf[0x45] =='M') {
	       strcpy (pre, "AST\0");		/*Actionanamics*/
	       strcpy (post, "\0");

   } else if (buf[26] == 'V' && buf[27] == '.' && buf[28] =='2') {
	       strcpy (pre, "BP\0");    	/* Soundmon V2*/
	       strcpy (post, "\0");

   } else if (buf[26] == 'V' && buf[27] == '.' && buf[28] =='3') {
	       strcpy (pre, "BP3\0");		/* Soundmon V2.2*/
	       strcpy (post, "\0");

   } else if (buf[60] == 'S' && buf[61] == 'O' && buf[62] =='N' && buf[63] =='G') {
	       strcpy (pre, "SFX13\0");		/* Sfx 1.3-1.8*/
	       strcpy (post, "\0");

   } else if (buf[124] == 'S' && buf[125] == 'O' && buf[126] =='N' && buf[127] =='G') {
	       strcpy (pre, "SFX20\0");		/* Sfx 2.0*/
	       strcpy (post, "\0");

   } else if (buf[0x1a] == 'E' && buf[0x1b] == 'X' && buf[0x1c] =='I' && buf[0x1d] =='T') {
	       strcpy (pre, "AAM\0");		/*Audio Arts & Magic*/
	       strcpy (post, "\0");
   } else if (buf[8] == 'E' && buf[9] == 'M' && buf[10] =='O' && buf[11] =='D' &&
	      buf[12] == 'E' && buf[13] =='M' && buf[14] =='I' && buf[15] =='C') {
	       strcpy (pre, "EMOD\0");		/* EMOD*/
	       strcpy (post, "\0");

   } else if (buf[0x24] == 'U' && buf[0x25] == 'N' && buf[0x26] =='C' && buf[0x27] =='L' &&
	      buf[0x28] == 'E' && buf[0x29] =='A' && buf[0x2a] =='R' && buf[0x2b] =='T') {
	       strcpy (pre, "DL\0");		/* DaveLowe Old (WT)*/
	       strcpy (post, "\0");

   } else if (buf[0x24] == 'D' && buf[0x25] == 'A' && buf[0x26] =='V' && buf[0x27] =='E' &&
	      buf[0x28] == 'L' && buf[0x29] =='O' && buf[0x2a] =='W' && buf[0x2b] =='E') {
	       strcpy (pre, "DL_deli\0");	/* DaveLowe Old (Deli)*/
	       strcpy (post, "\0");

   } else if (buf[0x24] == 'B' && buf[0x25] == 'E' && buf[0x26] =='A' && buf[0x27] =='T' &&
	      buf[0x28] == 'H' && buf[0x29] =='O' && buf[0x2a] =='V' && buf[0x2b] =='E') {
	       strcpy (pre, "BSS\0");		/* Beathoven Synthesizer */
	       strcpy (post, "\0");

   } else if (buf[0x24] == 'F' && buf[0x25] == 'R' && buf[0x26] =='E' && buf[0x27] =='D' &&
	      buf[0x28] == 'G' && buf[0x29] =='R' && buf[0x2a] =='A' && buf[0x2b] =='Y') {
	       strcpy (pre, "GRAY\0");		/* Fred Gray*/
	       strcpy (post, "\0");

   } else if (buf[0x24] == 'H' && buf[0x25] == '.' && buf[0x26] =='D' && buf[0x27] =='A' &&
	      buf[0x28] == 'V' && buf[0x29] =='I' && buf[0x2a] =='E' && buf[0x2b] =='S') {
	       strcpy (pre, "HD\0");		/* Howie Davies */
	       strcpy (post, "\0");

   } else if (buf[0x24] == 'R' && buf[0x25] == 'I' && buf[0x26] =='F' && buf[0x27] =='F' &&
	      buf[0x28] == 'R' && buf[0x29] =='A' && buf[0x2a] =='F' && buf[0x2b] =='F') {
	       strcpy (pre, "RIFF\0");		/* Riff Raff */
	       strcpy (post, "\0");

   } else if (buf[0x24] == '!' && buf[0x25] == 'S' && buf[0x26] =='O' && buf[0x27] =='P' &&
	      buf[0x28] == 'R' && buf[0x29] =='O' && buf[0x2a] =='L' && buf[0x2b] =='!') {
	       strcpy (pre, "SPL\0");		/* Soprol */
	       strcpy (post, "\0");

/* Magic ID at Offset 0x00 */
    } else if ((buf[0] == 'T' && buf[1] == 'F' && buf[2] =='M' && buf[3] == 'X')||
       (buf[0] == 't' && buf[1] == 'f' && buf[2] =='m' && buf[3] == 'x'))
    {
      if ((buf [4] == '-' &&  buf[5] == 'S' && buf[6] =='O' && buf[7] == 'N' && buf[8] == 'G' && buf[9] == ' ')||
	  (buf [4] == '_' &&  buf[5] == 'S' && buf[6] =='O' && buf[7] == 'N' && buf[8] == 'G' && buf[9] == ' ')||
	  (buf [4] == 'S' &&  buf[5] == 'O' && buf[6] =='N' && buf[7] == 'G')||
	  (buf [4] == 's' &&  buf[5] == 'o' && buf[6] =='n' && buf[7] == 'g')||
          (buf [4] == 0x20))
      {
	if ((buf [10] =='b'  && buf[11] =='y')  ||
	    (buf [16] == ' ' && buf[17] ==' ')  ||
	    (buf [16] == '(' && buf[17] =='E' && buf[18] == 'm' && buf[19] =='p' && buf[20] =='t' && buf[21] == 'y' && buf[22] ==')' ) ||
            (buf [16] == 0x30 && buf[17] == 0x3d) || /*lethal Zone*/
	    (buf [4]  == 0x20))
         {
	  if (buf[464]==0x00 && buf[465]==0x00 && buf[466]==0x00 && buf[467]==0x00)
	     {
	      if ((buf [14]!=0x0e && buf[15] !=0x60) || /*z-out title */
	         (buf [14]==0x08 && buf[15] ==0x60 && buf[4644] != 0x09 && buf[4645] != 0x0c)|| /* metal law */
	         (buf [14]==0x0b && buf[15] ==0x20 && buf[5120] != 0x8c && buf[5121] != 0x26)|| /* bug bomber */
	         (buf [14]==0x09 && buf[15] ==0x20 && buf[3876] != 0x93 && buf[3977] != 0x05)) /* metal preview */
    	         { 
	         strcpy (pre, "TFMX1.5\0");	/*TFMX 1.0 - 1.6*/
	         strcpy (post, "\0");
	         }
	      }

         } else if ((buf[0x0e]== 0x08 && buf[0x0f] ==0xb0) &&
		    (buf[0x140] ==0x00 && buf[0x141]==0x0b) && /*End tackstep 1st subsong*/
		    (buf[0x1d2]== 0x02 && buf[0x1d3] ==0x00) && /*Trackstep datas*/

    		    (buf[0x200] == 0xff && buf[0x201] ==0x00 && /*First effect*/
		     buf[0x202] == 0x00 && buf[0x203] ==0x00 &&
 		     buf[0x204] == 0x01 && buf[0x205] ==0xf4 && 
	    	     buf[0x206] ==0xff && buf[0x207] ==0x00)){
            		strcpy (pre, "TFMX7V\0");	/* mdat.BMW  TFMX 7V*/
    			strcpy (post, "\0");
	 } else {
		t=i=s=0;
		
		/*Trackstep datas offset*/
		if (buf[0x1d0] ==0x00 && buf[0x1d1] ==0x00 && buf[0x1d2] ==0x00 && buf[0x1d3] ==0x00) {
			/* unpacked*/
			s = 0x00000800; 
			} else {
			/*packed*/
			s = (buf[0x1d0] <<24) + (buf[0x1d1] <<16) + (buf[0x1d2] <<8) + buf[0x1d3]; /*packed*/
			}

		for (i =0; i<0x3d; i=i+2){
		    if (( (buf[0x140+i] <<8 ) +buf[0x141+i]) > 0x00 ){  /*subsong*/
			t = (((buf[0x100+i]<<8) +(buf[0x101+i]))*16 +s ); /*Start of subsongs Trackstep data :)*/
			e = (((buf[0x140+i]<<8) +(buf[0x141+i]))*16 +s ); /*End of subsongs Trackstep data :)*/

		      if (t < filesize || e < filesize){

			for (t=t ; t < e ; t=t+2) {
			    if (buf[t] == 0xef && buf[t+1] == 0xfe) {
				if (buf[t+2] == 0x00 && buf[t+3] == 0x03 &&
				    buf[t+4] == 0xff && buf[t+5] == 0x00 && buf[t+6] == 0x00){
				    t=e;
				    i=0x3d;
	            	            strcpy (pre, "TFMX7V\0");	/*TFMX 7V*/
    	    			    strcpy (post, "\0");
				    }
			    }
			}
		      }
	  	   }		    
		 }

    	}
    }	          
   } else if (buf[0] == 'A' && buf[1] == 'O' && buf[2] =='N') {
    	     if (buf[3] == '4')
	     {
	       strcpy (pre, "AON4\0");		/* Art Of Noise*/
	       strcpy (post, "\0");
	     } else {
	       strcpy (pre, "AON8\0");
	       strcpy (post, "\0");
	     }

   } else if (buf[0] == 'T' && buf[1] == 'H' && buf[2] =='X') {
    	     if (buf[3] == 0x00)
	     {
	       strcpy (pre, "AHX\0");		/* AHX */
	       strcpy (post, "\0");
	     } else {
	       strcpy (pre, "\0");
	       strcpy (post, "\0");
	     }


   } else if (buf[0x00] == 'A' && buf[0x01] == 'M' && buf[0x02] =='C' && buf[0x03] ==' ') {
	       strcpy (pre, "AMC\0");		/*AM-Composer*/
	       strcpy (post, "\0");

   } else if (buf[0x00] == 'A' && buf[0x01] == 'm' && buf[0x02] =='B' && buf[0x03] =='k') {
	       strcpy (pre, "ABK\0");		/*Amos*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'F' && buf[1] == 'U' && buf[2] =='C' && buf[3] =='O') {
	       strcpy (pre, "BSI\0");		/* Futurecomposer BSI*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'D' && buf[1] == 'I' && buf[2] =='G' && buf[3] =='I' &&
	      buf[5] == 'B' && buf[6] =='o' && buf[7] =='o'&& buf[8] =='s' && buf[9] =='t') {
	       strcpy (pre, "DB\0");		/* Digibooster*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'S' && buf[1] == 'O' && buf[2] =='A' && buf[3] =='R' &&
	      buf[4] == 'V' && buf[5] =='1' && buf[6] =='.'&& buf[7] =='0') {
	       strcpy (pre, "SA\0");		/* SonicArranger */
	       strcpy (post, "\0");

   } else if (buf[1] == 'M' && buf[2] == 'U' && buf[3] =='G' && buf[4] =='I' &&
	      buf[5] == 'C' && buf[6] =='I' && buf[7] =='A'&& buf[8] =='N'){ 
    	      if (buf[9] =='2') {
	       strcpy (pre, "DMU2\0");		/* Digimugi2*/
	       strcpy (post, "\0");
	      } else {
	       strcpy (pre, "DMU\0");		/* Digimugi*/
	       strcpy (post, "\0");
	      }

   } else if (buf[0] == 'M' && buf[1] == 'M' && buf[2] =='U' && buf[3] =='2') {
	       strcpy (pre, "DSS\0");		/* DSS*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'G' && buf[1] == 'L' && buf[2] =='U' && buf[3] =='E') {
	       strcpy (pre, "GLUE\0");		/* Gluemon*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'A' && buf[1] == 'R' && buf[2] =='P' && buf[3] == 0x2e) {
	       strcpy (pre, "MTP2\0");		/* HolyNoise / Major Tom*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'I' && buf[1] == 'S' && buf[2] =='M' && buf[3] == '!') {
	       strcpy (pre, "IS\0");		/* Instereo!*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'S' && buf[1] == 'M' && buf[2] =='O' && buf[3] =='D') {
	       strcpy (pre, "FC13\0");		/* Futurecomposer 1.3*/
	       strcpy (post, "\0");
	  
   } else if (buf[0] == 'F' && buf[1] == 'C' && buf[2] =='1' && buf[3] =='4') {
	       strcpy (pre, "FC14\0");		/* Futurecomposer 1.4*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'L' && buf[1] == 'M' && buf[2] =='E' && buf[3] ==0x00) {
	       strcpy (pre, "LME\0");		/* LegLess*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'M' && buf[1] == 'M' && buf[2] =='D' && buf[3] =='C') {
	       strcpy (pre, "MMDC\0");		/* MMDC*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'M' && buf[1] == 'S' && buf[2] =='O' && buf[3] =='B') {
	       strcpy (pre, "MSO\0");		/* Medley*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'M' && buf[1] == 'O' && buf[2] =='D' && buf[3] =='U') {
	       strcpy (pre, "NTP\0");		/* Novotrade*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'P' && buf[1] == 'S' && buf[2] =='A' && buf[3] == 0x00) {
	       strcpy (pre, "PSA\0");		/* PSA*/
	       strcpy (post, "\0");

   } else if ((buf[0] == 'S' && buf[1] == 'y' && buf[2] =='n' && buf[3] =='t' && buf[4] == 'h' && buf[6] == '.' && buf[8] == 0x00) && 
	     (buf[5] > '1' && buf[5] < '4')){
	       strcpy (pre, "SYN\0");		/* Synthesis*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'O' && buf[1] == 'B' && buf[2] =='I' && buf[3] =='S' &&
	      buf[4] == 'Y' && buf[5] =='N' && buf[6] =='T' && buf[7] =='H' &&
	      buf[8] == 'P' && buf[9] =='A' && buf[10] =='C' && buf[11] =='K') {
	       strcpy (pre, "OSP\0");		/* SynthPack*/
	       strcpy (post, "\0");


   } else if (buf[0] == 'C' && buf[1] == 'O' && buf[2] =='S' && buf[3] =='O') {
	       strcpy (pre, "HIPC\0");		/* Hippel Coso*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'B' && buf[1] == 'e' && buf[2] =='E' && buf[3] =='p') {
	       strcpy (pre, "JAM\0");		/* JAMCracker*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'A' && buf[1] == 'L' && buf[2] =='L' && buf[3] ==' ') {
	       strcpy (pre, "DM1\0");		/* Delta 1.0*/
	       strcpy (post, "\0");

   } else if (buf[0xbc6] == '.' && buf[0xbc7] == 'F' && buf[0xbc8] =='N' && buf[0xbc9] =='L') {
	       strcpy (pre, "DM2\0");		/* Delta 2.0*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'Y' && buf[1] == 'M' && buf[2] =='S' && buf[3] =='T') {
	       strcpy (pre, "YM\0");		/* MYST */
	       strcpy (post, "\0");
   } else if (buf[0] == 'Y' && buf[1] == 'M' && buf[3] =='!') {
	       strcpy (pre, "\0");		/* don't play stplay files*/
	       strcpy (post, "\0");

   } else if (buf[0] == 'O' && buf[1] == 'K' && buf[2] == 'T' && 
              buf[3] == 'A' && buf[4] == 'S' && buf[5] == 'O' &&
	      buf[6] == 'N' && buf[7] == 'G') {
	       strcpy (pre, "OKT\0");		/* Oktalyzer*/
	       strcpy (post, "\0");


   } else if (buf[0] == 'R' && buf[1] == 'J' && buf[2] =='P'){
   
             if ( buf[4] == 'S' && buf[5] == 'M' && buf[6] =='O' && buf[7] =='D') {
	        strcpy (pre, "RJP\0");		/* Vectordean (Richard Joseph Player)*/
	        strcpy (post, "\0");
		} else {
		strcpy (pre, "\0");		/* but don't play .ins files*/
	        strcpy (post, "\0");
		}
		  
   } else if ((buf[0] == 'P' && buf[1] == '4' && buf[2] =='0' && buf[3] =='A') ||
              (buf[0] == 'P' && buf[1] == '4' && buf[2] =='0' && buf[3] =='B') ||
              (buf[0] == 'P' && buf[1] == '4' && buf[2] =='1' && buf[3] =='A') ||
              (buf[0] == 'P' && buf[1] == '5' && buf[2] =='0' && buf[3] =='A') ||
              (buf[0] == 'P' && buf[1] == '6' && buf[2] =='0' && buf[3] =='A') ||
              (buf[0] == 'P' && buf[1] == '6' && buf[2] =='1' && buf[3] =='A')){
	       strcpy (pre, "P4x\0");		/* The Player */
	       strcpy (post, "\0");


   } else if (buf[2] == 0x03 && buf[3] == 0xf3){ /*CUSTOM*/

	t = 0;
	s = 0;
	i = (buf[0x0b]*4)+0x1c; /* beginning of first chunk */

	if (i < filesize - 0x42) {

	/* unfort. we can't always assume: moveq #-1,d0 rts before "delirium" */
	while ((buf[i+t+0] != 'D' && buf[i+t+1] !='E' && buf[i+t+2] != 'L' && buf[i+t+3] !='I') &&
	       (t < 0x40))  /*search 0x40 bytes from here, (enough?)*/
			    { 
			     t=t+1;
			    }
        if (t < 0x40){
	    /* longword after Delirium is rel. offset from first chunk 
	       where "hopefully" the delitags are*/
	    s = (buf[i+t+10]*256)+buf[i+t+11] + i;	/* 64K */
    	    if (s < filesize - 0x33) {

             for (i=0; i<0x30; i=i+4){
    	      if (buf[i+s+0] == 0x80 && buf[i+s+1] ==0x00 && 
	        buf[i+s+2] == 0x44 && buf[i+s+3] ==0x55){ 
		   strcpy (pre, "CUST\0");		/*last but not least */
		   strcpy (post, "\0");		/* CUSTOM*/
	           break;
	       }
             }
	    }
	}
      }
   } else if (buf[12] == 0x00){
	    s = (buf[12]*256 + buf[13] +1) * 14;
	    if (s < filesize-91){
    		if (buf[80+s] == 'p' && buf[81+s] == 'a' && buf[82+s] == 't' && buf[83+s] == 't' && buf[87+s] == 32 && 
	            buf[88+s] == 'p' && buf[89+s] == 'a' && buf[90+s] == 't' && buf[91+s] == 't')
		    {
		       strcpy (pre, "PUMA\0");		/* Pumatracker */
		       strcpy (post, "\0");
		    }
		}

  }
}
