#ifndef _DELIMSG_H_
#define _DELIMSG_H_

#include <stdlib.h>
#include <unistd.h>

typedef pid_t uadepid_t;

#define UADE_REBOOT 1
#define UADE_SETSUBSONG 2
#define UADE_NEXTSUBSONG 3
#define UADE_SONGEND 4
#define UADE_SONGINFO 5
#define UADE_PLAYERNAME 6
#define UADE_MODULENAME 7
#define UADE_SCORENAME 8
#define UADE_SUBSINFO 9
#define UADE_CHECKERROR 10
#define UADE_SCORECRASH 11
#define UADE_SCOREDEAD 12
#define UADE_GENERALMSG 13
#define UADE_NTSC 14
#define UADE_FORMATNAME 15
#define UADE_LOADFILE 16
#define UADE_READ 17
#define UADE_FILESIZE 18

typedef struct uade_mstruct {
  /* If this bit is set UADE will not write any sound data into shared mem */
  int dontwritebit;

  int touaemsgtype;

  char playername[256];
  char modulename[256];
  char scorename[256];

  int force_by_default;

  int setsubsongboolean;
  int subsong;
  int minsubsong;
  int maxsubsong;

  /* this is non-zero if emulator runs in ntsc state (not PAL) */
  int ntscbit;

  /* it this is non-zero emulated deliplayer can force song end to occure,
     otherwise not */
  int songendpossible;
  /* if a song ends, this is set non-zero */
  int songendboolean;

  /* if this is non-zero uade_prerun() loads needed information from this
     structure and starts playing */
  int loadnewsongboolean;

  int plugin_pause_boolean;
  int sbuf_writeoffset;
  int sbuf_readoffset;

  /* pid of xmms plugin */
  uadepid_t masterpid;

  /* this is set 1 after uade executable has inited itself (and starts
     to wait commands in uade_prerun() */
  int uade_inited_boolean;

  char score_playername[256];
  char score_playerauthor[256];	// still useless
  char score_modulename[256];
  char score_formatname[256];

  char soundbuffer[32768];

} uade_msgstruct;

#endif
